gokart_command:
  type: command
  name: gokart
  debug: false
  description: gokart
  usage: /gokart
  permission: gokart
  script:
  - create armor_stand gokart <player.location> save:gokart
  - define gokart <entry[gokart].created_npc>
  - adjust <[gokart]> set_assignment:gokart_npc


gokart_npc:
  type: assignment
  debug: false
  actions:
    on assignment:
    - adjust <npc> visible:false
    - adjust <npc> name_visible:false
    - adjust <npc> silent:true
    - trigger name:damage state:true
    - equip head:<item[stick].with[custom_model_data=8]>
    on click:
    - if <player.is_sneaking>:
      - remove <npc>
      - stop
    - mount <player>|<npc>
    - flag player gokart

gokart_handler:
  type: world
  debug: false
  events:
    on player steers entity flagged:gokart:
    - define npc <context.entity>
    - define npc_loc <[npc].location>
    - look <[npc]> yaw:<player.eye_location.yaw>
    - if <player.has_flag[gokart.jumped]>:
      - define y 2
    - else if <context.jump> && <[npc_loc].below.material.name> != air && !<player.has_flag[gokart.jump_cooldown]>:
      - define y 2
      - flag player gokart.jumped duration:3t
      - flag player gokart.jump_cooldown duration:2s
    - else:
      - define y -1
    - adjust <[npc]> velocity:<[npc_loc].forward[<context.forward>].sub[<[npc_loc]>].normalize.with_y[<[y]>]>
    - if <context.forward> != 0 && !<[npc].has_flag[gokart_sound_cooldown]>:
      - playsound <[npc_loc]> sound:BLOCK_ANCIENT_DEBRIS_STEP volume:1.2 pitch:1.5
      - playsound <[npc_loc]> sound:BLOCK_NETHERITE_BLOCK_BREAK volume:1.2 pitch:1.5
      - flag <[npc]> gokart_sound_cooldown duration:1t
    - if <context.dismount>:
      - flag player gokart:!