hotdogcar_command:
  type: command
  name: hotdogcar
  debug: false
  description: hotdogcar
  usage: /hotdogcar
  permission: hotdogcar
  script:
  - create armor_stand hotdogcar <player.location> save:hotdogcar
  - define hotdogcar <entry[hotdogcar].created_npc>
  - adjust <[hotdogcar]> set_assignment:hotdogcar_npc
  - adjust <player> selected_npc:<[hotdogcar]>


hotdogcar_npc:
  type: assignment
  debug: false
  actions:
    on assignment:
    - adjust <npc> visible:false
    - adjust <npc> name_visible:false
    - adjust <npc> silent:true
    - trigger name:damage state:true
    - equip head:<item[bread].with[custom_model_data=1]>
    on click:
    - if <player.is_sneaking>:
      - remove <npc>
      - stop
    - mount <player>|<npc>
    - flag player hotdogcar

hotdogcar_handler:
  type: world
  debug: false
  events:
    on player steers entity flagged:hotdogcar:
    - define npc <context.entity>
    - define npc_loc <[npc].location>
    - look <[npc]> yaw:<player.eye_location.yaw>
    - if <player.has_flag[hotdogcar.jumped]>:
      - define y 2
    - else if <context.jump> && <[npc_loc].below.material.name> != air && !<player.has_flag[hotdogcar.jump_cooldown]>:
      - define y 2
      - flag player hotdogcar.jumped duration:3t
      - flag player hotdogcar.jump_cooldown duration:2s
    - else:
      - define y -1
    - adjust <[npc]> velocity:<[npc_loc].forward[<context.forward>].sub[<[npc_loc]>].normalize.with_y[<[y]>]>
    - if <context.forward> != 0 && !<[npc].has_flag[hotdogcar_sound_cooldown]>:
      - playsound <[npc_loc]> sound:entity_player_attack_sweep volume:0.5 pitch:1.5
      - flag <[npc]> hotdogcar_sound_cooldown duration:1t
    - if <context.dismount>:
      - flag player hotdogcar:!