bananarang_command:
  type: command
  name: bananarang
  debug: false
  description: bananarang
  usage: /bananarang
  permission: bananarang
  script:
  - give bananarang

bananarang:
  type: item
  material: stick
  display name: swhoom
  debug: false
  mechanisms:
    custom_model_data: 13

bananarang_handler:
  type: world
  debug: false
  events:
    on player left clicks block with:bananarang:
    - define eye_loc <player.eye_location.forward>
    - if <player.target||null> != null:
      - define target_loc <[eye_loc].forward[<[eye_loc].distance[<player.target.location>]>]>
    - else:
      - define target_loc <[eye_loc].ray_trace[50]||null>
    - if <[target_loc]> == null:
      - actionbar "<&c>Not facing anything."
      - stop

    - define speed 3

    - define points <[eye_loc].points_between[<[target_loc]>].distance[<[speed]>]>
    - define item <player.item_in_hand>

    - playsound <[eye_loc]> sound:ENTITY_ENDER_PEARL_THROW pitch:0.6 volume:1.2

    - take slot:<player.held_item_slot>
    - spawn snowball[item=<[item]>;glowing=true] <[eye_loc]> save:nokia
    - define nokia <entry[nokia].spawned_entity>

    - while <[nokia].location.distance[<[target_loc]>]||0> > 1:
      - if !<[nokia].is_spawned>:
        - while stop
      - adjust <[nokia]> velocity:<[target_loc].sub[<[nokia].location>].normalize.mul[3]>
      - wait 1t

    #if it isn't spawned, someone else has probably picked it up (?)
    - if <[nokia].is_spawned>:
      - remove <[nokia]>

    #-effects
    - playsound <[target_loc]> sound:ITEM_TOTEM_USE pitch:0.5 volume:2
    - playeffect effect:FLASH quantity:100 visibility:500 at:<[target_loc]> offset:3

    #-hurt
    - hurt 200 <[target_loc].find_entities.within[10]>

    #-blocks
    - define blocks <[target_loc].find_blocks.within[10].filter[material.name.equals[BEDROCK].not]>
    - if !<[blocks].is_empty>:
      - define block_data <[blocks].random[25].parse_tag[<[Parse_Value].simple>/<[Parse_Value].material.name>]>
    - modifyblock <[blocks]> air
    - if <[block_data].exists>:
      - foreach <[block_data]> as:B:
        - define Material <[B].after[/]>
        - define Loc <[B].before[/].as_location.center>
        - spawn <entity[FALLING_BLOCK].with[fallingblock_type=<[Material]>]> <[Loc]> save:<[B]>
        - define Block_Entity <entry[<[B]>].spawned_entity>
        - adjust <[Block_Entity]> velocity:<[Loc].sub[<[target_loc]>].with_y[2]>
        - define Entities:->:<[Block_Entity]>

    - define crack_blocks <[target_loc].find_blocks.within[11]>
    - foreach <[crack_blocks]> as:block:
      - blockcrack <[block]> progress:5 players:<server.online_players>

    - spawn snowball[item=<[item]>;glowing=true] <[target_loc]> save:nokia
    - define nokia <entry[nokia].spawned_entity>
    #-
    - while <player.is_online> && <[nokia].location.distance[<player.eye_location>]||0> > 1:
      - if !<[nokia].is_spawned>:
        - while stop
      #- teleport <[nokia]> <[nokia].location.face[<player.location>].forward[<[speed]>]>
      - adjust <[nokia]> velocity:<player.eye_location.sub[<[nokia].location>].normalize.mul[3]>
      - wait 1t

    - if <[nokia].is_spawned>:
      - remove <[nokia]>

    - give <[item]> quantity:1