flashbang_command:
  type: command
  name: flashbang
  debug: false
  description: flashbang
  usage: /flashbang
  permission: flashbang
  script:
  - give flashbang

flashbang:
  type: item
  material: stone_button
  display name: FLASHY WASHY
  debug: false
  enchantments:
  - sharpness:1000
  mechanisms:
    hides: ALL

flashbang_handler:
  type: world
  debug: false
  events:
    after player left clicks block with:flashbang:
    - take slot:<player.held_item_slot>
    - drop flashbang <player.location> save:i
    - define i <entry[i].dropped_entity>
    - shoot <[i]> speed:0.8 height:3 script:flashbang_script

flashbang_script:
  type: task
  debug: false
  definitions: data
  script:
  - wait 1s
  - define entities <[location].find_entities.within[50]>
  - foreach <[entities]> as:e:
    - if <[e].location.facing[<[location]>]>:
      - run flashbang_script path:flash def:<map.with[target].as[<[e]>]>
  flash:
  - define target <[data].get[target]>
  - repeat 100:
    - playeffect effect:REDSTONE at:<[target].eye_location.forward[0.3]> offset:0.3 quantity:20 special_data:1.2|WHITE
    - wait 1t
