gun_command:
  type: command
  name: gun
  debug: false
  description: gun
  usage: /gun
  permission: gun
  script:
   - give gun_item

gun_item:
  type: item
  material: stick
  display name: <&f><&l>Gun <&7>30 <&8><&l>| <&a>∞
  lore:
  - <empty>
  - <&7>gun go pew pew.
  - <empty>
  - <&7>sub to nimsy.
  mechanisms:
    hides: ALL
    custom_model_data: 19
  flags:
    Gun: True
    Clip: 25
  enchantments:
  - sharpness:1


gun_reload:
  type: task
  debug: false
  script:
  - inventory adjust slot:<[Slot]> flag:Reloading:True
  - inventory adjust slot:<[Slot]> "display_name:<&f><&l>Gun <&7>0 <&8><&l>| <&a>∞ <&7>(<&c>Reloading...<&7>)"
  - wait 50t
  - inventory adjust slot:<[Slot]> flag:Clip:25
  - inventory adjust slot:<[Slot]> "display_name:<&f><&l>Gun <&7>25 <&8><&l>| <&a>∞"
  - inventory adjust slot:<[Slot]> flag:Reloading:!

gun_mechanics:
  type: world
  debug: false
  events:
    on player right clicks block with:gun_item:
    - if <context.item.has_flag[Reloading]> || <player.has_flag[Gun_CD]>:
      - stop
    - define Slot <player.held_item_slot>
    - inventory adjust slot:<[Slot]> flag:Clip:--
    - inventory adjust slot:<[Slot]> "display_name:<&f><&l>Gun <&7><context.item.flag[Clip].sub[1]> <&8><&l>| <&a>∞"
    - define Target <player.target||null>
    - if <[Target]> != null:
      - define Loc <player.eye_location.forward[<player.eye_location.distance[<[Target].location>]>]>
      - if <player.location.distance[<[Target].location>]> > 50:
        - define Loc <player.eye_location.forward[50]>
    - else:
      - define Loc <player.eye_location.forward[50]>
    - define Points <player.eye_location.forward[1.5].points_between[<[Loc]>]>
    - playeffect effect:CRIT at:<[Points]> quantity:1 offset:0 visibility:500
    - playsound <player.location> sound:ENTITY_FIREWORK_ROCKET_LARGE_BLAST pitch:1 volume:1.2
    - playsound <player.location> sound:BLOCK_STONE_HIT pitch:1 volume:1.2
    - if <[Target]> != null && <[Target].is_spawned>:
      - hurt 2 <[Target]> source:<player>
    - if <context.item.flag[Clip].sub[1]> == 0:
      - inject Gun_Reload
      - stop
    #to not let players spam the gun while clicking
    - flag player Gun_CD duration:3t