shrek_command:
  type: command
  name: shrek
  debug: false
  description: shrek
  usage: /shrek
  permission: shrek
  script:
   - create player Shrek <player.location> save:shrek
   - adjust <entry[shrek].created_npc> set_assignment:shrek_AI
   - give onion

onion:
  type: item
  #WOODEN_SHOVEL
  material: player_head
  display name: onion (reserved for shrek only)
  debug: false
  mechanisms:
    skull_skin: d100b6b0-4892-1e1a-07b9-6497e4b65332|eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvYTZlY2M0NmRjM2RjODVmY2Q1NzE5ODE3NmVlODQxZjFhMDQxYjE1ZjczZWNiMTlmZGU2MmVlNDMxNWM0YTYifX19

shrek_AI:
  type: assignment
  debug: false
  actions:
    on assignment:
    - lookclose
    - trigger name:damage state:true
    - vulnerable state:true
    - trigger name:proximity state:true radius:3
    - trait MobProx
    on click:
    - if <npc.has_flag[friended]>:
      - stop
    - if <player.item_in_hand.script.name||null> != onion:
      - stop
    - flag <npc> friended
    - flag <player> shrek_friended:<npc>
    - wait 1t
    - take slot:<player.held_item_slot>
    - playsound <npc.location> sound:ENTITY_PLAYER_BURP pitch:0 volume:1.2
    - wait 5t
    - narrate "[shrek] yummy, let's be friends"
    - define distance 3
    - while <npc.is_spawned> && <player.is_online>:
      - if <player.location.distance[<npc.location>]> > <[distance]>:
        - ~walk <npc> <player.location.random_offset[3,0,3]> speed:1.5 lookat:<player.eye_location>
      - wait 1t
    - flag <npc> friended:!
    - flag <player> shrek_friended:!

shrek_handler:
  type: world
  debug: false
  events:
    on player enters biome biome:swamp flagged:shrek_friended:
    - narrate "[shrek] HEY! ANYWHERE BUT MY SWAMP, B!@$#"
    - wait 1s
    - hurt 999 <player> source:<npc>
