necromancer_staff_command:
  type: command
  name: necromancer_staff
  debug: false
  description: necromancer_staff
  usage: /necromancer_staff
  permission: necromancer_staff
  script:
  - give necromancer_staff


necromancer_staff:
  type: item
  material: stick
  display name: the dead shall rise
  debug: false

necromancer_staff_handler:
  type: world
  debug: false
  events:
    on player right clicks block with:necromancer_staff:
    - if <player.target||null> == null || <player.target.entity_type> != ZOMBIE:
      - stop
    - define target <player.target>
    - if <[target].has_flag[controller]>:
      - flag <[target]> controller:!
      - stop
    - flag <[target]> controller:<player>
    - while <[target].is_spawned> && <[target].has_flag[controller]> && <player.is_online>:
      - playeffect at:<[target].location.above[2.5]> effect:REDSTONE quantity:1 offset:0 visibility:500 special_data:1.5|RED
      - wait 3t
    - flag <[target]> controller:!
    on player left clicks block with:necromancer_staff:
    - if <player.eye_location.ray_trace||null> == null:
      - stop
    - define controlled_entities <player.world.entities[zombie].filter[has_flag[controller]].filter[flag[controller].equals[<player>]]>
    - if <[controlled_entities].is_empty>:
      - stop
    - define dest <player.eye_location.ray_trace>
    - ~walk <[controlled_entities]> <[dest]> speed:0.2