ufo_command:
  type: command
  name: ufo
  debug: false
  description: ufo
  usage: /ufo
  permission: ufo
  script:
  - create armor_stand ufo <player.location> save:ufo
  - define ufo <entry[ufo].created_npc>
  - adjust <[ufo]> set_assignment:ufo_npc


ufo_npc:
  type: assignment
  debug: false
  actions:
    on assignment:
    - adjust <npc> visible:false
    - adjust <npc> name_visible:false
    - adjust <npc> silent:true
    - trigger name:damage state:true
    - equip head:<item[stick].with[custom_model_data=24]>
    on click:
    - if <player.is_sneaking>:
      - remove <npc>
      - stop
    - mount <player>|<npc>
    - flag player ufo

ufo_handler:
  type: world
  debug: false
  events:
    on player steers entity flagged:ufo:
    - define npc <context.entity>
    - define npc_loc <[npc].location>
    - playsound <[npc_loc]> sound:BLOCK_BEACON_AMBIENT volume:1.2 pitch:2
    - look <[npc]> yaw:<player.eye_location.yaw>
    - if <context.jump>:
      - define y 1
    - adjust <[npc]> velocity:<[npc_loc].forward[<context.forward>].sub[<[npc_loc]>].normalize.with_y[<[y]||0>]>
    - if <context.forward> != 0 && !<[npc].has_flag[ufo_sound_cooldown]>:
      - playsound <[npc_loc]> sound:BLOCK_BEACON_ACTIVATE volume:1.2 pitch:2
      - flag <[npc]> ufo_sound_cooldown duration:1t
    - if <context.dismount>:
      - flag player ufo:!