flypig_command:
  type: command
  name: flypig
  debug: false
  description: flypig
  usage: /flypig
  permission: flypig
  script:
  - create pig pig <player.location.above[2]> save:pig
  - define pig <entry[pig].created_npc>
  - adjust <[pig]> set_assignment:pig_AI

pig_AI:
  type: assignment
  debug: false
  actions:
    on assignment:
    - lookclose
    - trigger name:damage state:true
    - vulnerable state:true
    - trigger name:proximity state:true radius:3
    - adjust <npc> name_visible:false
    - adjust <npc> gravity:false
    - while <npc.is_spawned>:
      - if <util.random.int[1].to[100]> <= 50:
        - rotate <npc> duration:1s freqeuency:1t
        - wait 1s
      - define dest <npc.location.random_offset[<util.random.int[2].to[6]>,0,<util.random.int[2].to[6]>]>
      - define points <npc.location.points_between[<[dest]>].distance[0.3]>
      - foreach <[points]> as:p:
        - teleport <npc> <[p]>
        - wait 1t
      - wait 1s