redbull_command:
  type: command
  name: redbull
  debug: false
  description: redbull
  usage: /redbull
  permission: redbull
  script:
  - give redbull

redbull:
  type: item
  material: player_head
  display name: WINGS
  debug: false
  mechanisms:
    skull_skin: a749e452-069a-47d6-b6a9-b886c6a5d887|eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvNzY2ODQ0ZDVlODRmNjQ5NDUxYTg3ZGFjY2E3YTczYmVhYTA0ZWVhODQ3ZDQzOGRlMjZjMmQ0NGQxZTk0OWRlIn19fQ

redbull_handler:
  type: world
  debug: false
  events:
    on player right clicks block with:redbull:
    - take slot:<player.held_item_slot>
    - playsound <player> sound:ENTITY_PLAYER_BURP
    - wait 1s
    - flag player redbull duration:7s
    - while <player.is_online> && <player.has_flag[redbull]>:
      - define Hex1 <util.random.int[0].to[255]>
      - define Hex2 <util.random.int[0].to[255]>
      - define Hex3 <util.random.int[0].to[255]>
      - define Color <color[<[Hex1]>,<[Hex2]>,<[Hex3]>]>
      - define Loc <player.eye_location>
      - playeffect effect:DRAGON_BREATH at:<[Loc].forward> offset:12 quantity:450 velocity:<[Loc].direction.vector.mul[-1].with_y[0]>
      - playeffect effect:REDSTONE at:<[Loc].forward> offset:0.6 quantity:100 special_data:1.2|<[Color]>
      - playeffect effect:FLAME offset:0.2 quantity:3 at:<player.location.backward.above>
      - adjust <player> velocity:<player.location.forward.sub[<player.location>].mul[50]>
      - wait 1t
    - explode <player.location> power:8