veg_command:
  type: command
  name: veg
  debug: false
  description: veg
  usage: /veg
  permission: veg
  script:
  - if <player.has_flag[veg]>:
    - narrate "<&c>You are no longer a vegeterian."
    - flag player veg:!
    - stop
  - flag player veg
  - narrate "<&a>You now vegetarian!"

veg_data:
  type: data
  whitelist:
    - apple
    - mushroom_stew
    - bread
    - golden_apple
    - enchanted_golden_apple
    - cake
    - cookie
    - melon_slice
    - dried_kelp
    - spider_eye
    - potato
    - baked_potato
    - poisonous_potato
    - pumpking_pie
    - glow_berries
    - sweet_berries
    - beetroot_soup
    - beetroot
    - honey_bottle
    - potion
    - carrot
    - golden_carrot

veg_handler:
  type: world
  debug: false
  events:
    on player consumes item flagged:veg:
    - if <script[veg_data].data_key[whitelist].contains[<context.item.material.name>]>:
      - stop
    - title "subtitle:<&c>YOU HAVE BROKEN THE LAWS OF VEGETARIANISM"
    - repeat 10:
      - define loc <player.location>
      - wait 10t
      - strike <[loc]>
