lebron_command:
  type: command
  name: lebron
  debug: false
  description: lebron
  usage: /lebron
  permission: lebron
  script:
   - create player LebronJames <player.location> save:lebron
   - adjust <entry[lebron].created_npc> set_assignment:lebron_AI

basketball:
  type: item
  #WOODEN_SHOVEL
  material: player_head
  display name: basketball
  debug: false
  mechanisms:
    skull_skin: 9a869760-a4ae-49ac-9598-e136ce74ba73|eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvZWRmODQ3MTVhNjRkYzQ1NTg2ZjdhNjA3OWY4ZTQ5YTk0NzdjMGZlOTY1ODliNGNmZDcxY2JhMzIyNTRhYzgifX19


lebron_AI:
  type: assignment
  debug: false
  actions:
    on assignment:
    - lookclose <npc> state:true range:5
    - trigger name:damage state:true
    - vulnerable state:true
    - trigger name:proximity state:true radius:3
    - trait MobProx
    - drop basketball <npc.location.forward_flat> save:i
    - define i <entry[i].dropped_entity>
    - flag <[i]> host:<npc>
    - while <npc.is_spawned>:
      - teleport <[i]> <npc.location.forward_flat>
      - adjust <[i]> velocity:0,0.35,0
      - waituntil <[i].is_on_ground>
      - wait 1t
    - remove <[i]>
    on enter proximity:
    - narrate "[lebron] Yo, try to steal the ball from me, nerd."

basketball_handler:
  type: world
  debug: false
  events:
    on player picks up basketball:
    - determine passively cancelled
    - if <context.entity.has_flag[host]> && !<context.entity.has_flag[cooldown]>:
      - define leb <context.entity.flag[host]>
      - playsound <[leb].location> sound:ENTITY_PLAYER_ATTACK_SWEEP pitch:1.5
      - adjust <[leb]> velocity:<[leb].location.random_offset[1].sub[<[leb].location>].normalize>
      - flag <context.entity> cooldown duration:2s

