scythe_command:
  type: command
  name: scythe
  debug: false
  description: scythe
  usage: /scythe
  permission: scythe
  script:
   - give scythe

scythe:
  type: item
  #WOODEN_SHOVEL
  material: stick
  display name: scythe (very scary yes)
  debug: false
  mechanisms:
    custom_model_data: 1

scythe_handler:
  type: world
  debug: false
  events:
    on player clicks block with:scythe:
    - define Loc <player.eye_location.forward.below[0.2]>
    - define Yaw <[Loc].yaw>
    - define Pitch <[Loc].pitch>
    - playsound <player> sound:ENTITY_PLAYER_ATTACK_SWEEP pitch:0.8 volume:1.2
    - repeat 5:
      - define Points <util.list_numbers_to[<element[36].mul[<[Value]>]>].parse_tag[<[Loc].add[<location[0,0,0].with_pose[<[Pitch]>,<[Yaw]>].left[<[Value].div[2]>].rotate_around_y[<[Parse_Value].to_radians.mul[-1]>]>]>]>
      - playeffect effect:REDSTONE at:<[Points]> quantity:1 offset:0.1,0,0.1 visibility:300 special_data:0.4|WHITE
      - hurt <[Points].last.find_entities.within[1.2].exclude[<player>]> 10
      - modifyblock <[Points].filter[material.name.is[!=].to[BEDROCK]]> air naturally
      - wait 1t