dino_nuggies_command:
  type: command
  name: dino_nuggies
  debug: false
  description: dino_nuggies
  usage: /dino_nuggies
  permission: dino_nuggies
  script:
  - give dino_nuggies

dino_nuggies:
  type: item
  #WOODEN_SHOVEL
  material: gold_nugget
  display name: dinosorical nugget of thoust being
  debug: false
  mechanisms:
    custom_model_data: 10

dino_nuggies_handler:
  type: world
  debug: false
  events:
    after player right clicks block with:dino_nuggies:
    - take slot:<player.held_item_slot>
    - playsound <player> sound:ENTITY_PLAYER_BURP
    - title subtitle:yes fade_in:5t stay:5t fade_out:5t
    - cast INVISIBILITY duration:15s no_ambient no_icon hide_particles
    - mount <player>|tropical_fish[flag=dino_nuggies:true]
    - flag player dino_nuggies duration:10s
    on player steers tropical_fish flagged:dino_nuggies:
    - define npc <context.entity>
    - define npc_loc <[npc].location>
    - look <[npc]> yaw:<player.eye_location.yaw>
    - if <player.has_flag[dino.jumped]>:
      - define y 2
    - else if <context.jump> && <[npc_loc].below.material.name> != air && !<player.has_flag[dino.jump_cooldown]>:
      - define y 2
      - flag player dino.jumped duration:3t
      - flag player dino.jump_cooldown duration:2s
    - else:
      - define y -1
    - adjust <[npc]> velocity:<[npc_loc].forward[<context.forward>].sub[<[npc_loc]>].normalize.with_y[<[y]>]>
    - if <context.forward> != 0 && !<[npc].has_flag[dino_sound_cooldown]>:
      - playsound <player> sound:ENTITY_FISH_SWIM pitch:2
      - flag <[npc]> dino_sound_cooldown duration:1t
    - if <[npc].is_on_ground>:
      - adjust <player> velocity:0,0.6,0
    - if !<player.has_flag[dino_nuggies]> || <context.dismount>:
      - remove <[npc]>
      - cast INVISIBILITY remove <player>
    on tropical_fish damaged flagged:dino_nuggies:
    - determine cancelled
