fort_command:
  type: command
  name: fort
  debug: false
  description: fort
  usage: /fort
  permission: fort
  script:
  - if <player.has_flag[fort]>:
    - actionbar "fort disabled"
    - inventory clear
    - inventory set d:<player.inventory> o:<player.flag[fort.saved_inventory]>
    - flag player fort:!
    - stop
  - actionbar "fort enabled"
  - flag player fort
  - flag player fort.saved_inventory:<player.inventory.list_contents>
  - inventory clear
  - define floor <item[oak_slab].with[display_name.<&b>Floor]>
  - define stair <item[oak_stairs].with[display_name.<&b>Stair]>
  - define wall <item[oak_planks].with[display_name.<&b>Wall]>
  - give <[floor]>|<[stair]>|<[wall]>
  - while <player.has_flag[fort]> && <player.is_online>:
    - actionbar "fortnite mode enabled"
    - if <player.item_in_hand.material.name> != air:
      - define loc <player.location.forward_flat.up>
      - choose <player.item_in_hand.material.name.after[_]>:
        #floor
        - case slab:
          - define min <[loc].left[2]>
          - define max <[loc].forward_flat[2].right[2]>
          - define cuboid <cuboid[<[min]>|<[max]>]>
        #stair
        - case stairs:
          - define min <[loc].left[2]>
          - define max <[loc].forward_flat[2].right[2]>
          - define cuboid <cuboid[<[min]>|<[max]>]>
        #wall
        - case planks:
          - define min <[loc].left[2]>
          - define max <[loc].above[2].right[2]>
          - define cuboid <cuboid[<[min]>|<[max]>]>
      - playeffect effect:redstone at:<[cuboid].outline> quantity:1 offset:0 visibility:500 special_data:0.6|AQUA
    - wait 1t
  - flag player fort:!

fort_handler:
  type: world
  debug: false
  events:
    on player clicks block flagged:fort with:oak_*:
    - determine passively cancelled
    - define loc <player.location.forward_flat.up>
    - choose <context.item.material.name.after[_]>:
      #floor
      - case slab:
        - define min <[loc].left[2]>
        - define max <[loc].forward_flat[2].right[2]>
        - define cuboid <cuboid[<[min]>|<[max]>]>
        - modifyblock <[cuboid]> oak_planks
      #stair
      - case stairs:
        - define min <[loc].left[2]>
        - define max <[loc].forward_flat[2].right[2]>
        - define cuboid <cuboid[<[min]>|<[max]>]>
        - modifyblock <[cuboid]> oak_stairs
      #wall
      - case planks:
        - define min <[loc].left[2]>
        - define max <[loc].above[2].right[2]>
        - define cuboid <cuboid[<[min]>|<[max]>]>
        - modifyblock <[cuboid]> oak_planks
    on player clicks in inventory flagged:fort:
    - determine cancelled
    on player drops item flagged:fort:
    - determine cancelled
    on player picks up item flagged:fort:
    - determine cancelled