axe_guitar_command:
  type: command
  name: axe_guitar
  debug: false
  description: axe_guitar
  usage: /axe_guitar
  permission: axe_guitar
  script:
  - give axe_guitar


axe_guitar:
  type: item
  material: stick
  display name: ROCK ON YUH
  debug: false
  mechanisms:
    custom_model_data: 26

axe_guitar_handler:
  type: world
  debug: false
  events:
    on player right clicks block with:axe_guitar:
    - repeat 4:
      - run axe_guitar_handler path:shoot
      - wait 1t
  shoot:
  - if <player.target||null> != null:
    - define target <player.target>
    - define target_loc <player.eye_location.forward[<player.location.distance[<player.target.location>]>]>
  - else:
    - define target_loc <player.eye_location.forward[50]>
  - define points <player.eye_location.forward.points_between[<[target_loc]>]>
  - foreach <[points].sub_lists[20]> as:p_list:
    - playsound <[p_list].first> sound:BLOCK_NOTE_BLOCK_GUITAR pitch:<util.random.decimal[0].to[2]>
    - playsound <[p_list].first> sound:BLOCK_NOTE_BLOCK_BIT pitch:<util.random.decimal[0].to[2]>
    - playeffect effect:note visibility:500 offset:0.2 quantity:1 at:<[p_list]> data:1
    - wait 1t
  - if <[target].exists>:
    - hurt 4 <[target]> source:<player>