soda_can_command:
  type: command
  name: soda_can
  debug: false
  description: soda_can
  usage: /soda_can
  permission: soda_can
  script:
  - give soda_can

soda_can:
  type: item
  material: player_head
  display name: sody pody
  debug: false
  mechanisms:
    skull_skin: e4dfd534-d48b-4a52-880a-9b4e1c3aa8ef|eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvNDgxNDAwYmUzNmI0YjA4NjY5YzAwMTg1YWQwODIxYzhmZDRkZjlmYjM3ZGExNGFjY2VhYWIzMzE4NzRiNTk1ZiJ9fX0

soda_can_handler:
  type: world
  debug: false
  events:
    after player holds item item:soda_can:
    - while <player.item_in_hand.script.name||null> == soda_can:
      - if <player.has_flag[plasma_charge]>:
        - playeffect effect:REDSTONE at:<player.eye_location.forward[0.5].right[0.5].below[0.5]> offset:0.2 quantity:6 special_data:1|WHITE
      - wait 1t
    on player right clicks block with:soda_can:
    - determine passively cancelled
    - if <player.flag[plasma_charge]||0> >= 8:
      - actionbar <&a><&l>[FULL]
      - stop
    - define item <player.item_in_hand>
    - take slot:<player.held_item_slot>
    - wait 2t
    - give <[item]>
    - playsound <player> sound:BLOCK_NOTE_BLOCK_BASS pitch:0
    - flag player plasma_charge:++
    - if <player.flag[plasma_charge]> == 8:
      - playsound <player> sound:ENTITY_FISH_SWIM pitch:1.5
      - actionbar <&a><&l>[FULL]
    - else:
      - actionbar <list[].pad_right[<player.flag[plasma_charge].round>].with[<&chr[6969]>].pad_right[8].with[<&chr[4200]>].replace[<&chr[6969]>].with[<green>╏].replace[<&chr[4200]>].with[<&c>╏].separated_by[<empty>]>
    on player left clicks block with:soda_can:
    - determine passively cancelled
    - if <player.flag[plasma_charge]||0> < 8:
      - actionbar "<&c><&l>[NOT FULL]"
      - stop
    - flag player plasma_charge:!
    - actionbar <&b><&l>⚡⚡⚡
    - repeat 100:
      - playsound <player> sound:ENTITY_FISH_SWIM pitch:0.5
      - playeffect effect:CLOUD at:<player.eye_location.forward> offset:0.4 quantity:5 velocity:<player.eye_location.forward[2].sub[<player.eye_location.forward[1]>]>
      - wait 1t