tnt_tree_command:
  type: command
  name: tnt_tree
  debug: false
  description: tnt_tree
  usage: /tnt_tree
  permission: tnt_tree
  script:
  - if <server.has_flag[tnt_tree]>:
    - actionbar "tnt tree disabled"
    - flag server tnt_tree:!
    - stop
  - actionbar "tnt tree enabled"
  - flag server tnt_tree

tnt_tree_handler:
  type: world
  debug: false
  events:
    on player breaks *log:
    - if !<server.has_flag[tnt_tree]>:
      - stop
    - repeat 100:
      - wait 2t
      - define loc <context.location.above[<[value]>]>
      - if <[loc].material.name> == air:
        - repeat stop
      - if <[loc].material.name.contains_text[log]>:
        - playsound <[loc]> sound:BLOCK_WOOD_BREAK
      - if <[loc].material.name.contains_text[leaves]>:
        - playsound <[loc]> sound:BLOCK_GRASS_BREAK
      - modifyblock <[loc]> air naturally
    - define leaves <[loc].find_blocks.within[5].filter[material.name.contains_text[LEAVES]]>
    - repeat <[leaves].size>:
      - playsound <[loc]> sound:BLOCK_GRASS_BREAK
    - modifyblock <[leaves]> air naturally
    - repeat 10:
      - spawn primed_tnt[fuse_ticks=30] <[loc]>

